/***************************************************
 
  Exploring Bos Taurus of Dr. CLAUDIO SOTO from Uruguay
 
  Image converter
  
 
 ******************************************************************************
 
Bos Taurus :

  AUTOR:    Dr. CLAUDIO SOTO
  PAIS:     URUGUAY
  E-MAIL:   srvet@adinet.com.uy
  BLOG:     http://srvet.blogspot.com

Sample by : esgici
  
***************************************************/

#include "hmg.ch"
#include "hfcl.ch"


PROCEDURE Main()

   SET CENT ON
   SET DATE GERM
   
   hImage      := 0
   cImgFilName := ''
   
   DEFINE WINDOW frmBTExp_IC;
      AT 0,0;
      WIDTH  700;
      HEIGHT 600;
      TITLE "Exploring Bos Taurus for HMG  -- Image Converter";
      ICON "BT_Icon" ;
      ON INIT BTExp_OpenImgFile() ; 
      ON RELEASE BT_BitmapRelease ( hImage ) ;
      MAIN
      
      ON KEY ESCAPE         ACTION ThisWindow.Release
      
      DEFINE MAIN MENU 
      
			DEFINE POPUP '&File'
         
            ITEM "&Open"            NAME mit_RFile      ACTION BTExp_OpenImgFile()
               
            DEFINE POPUP  '&Save As ...'  NAME mitSaveAs
               ITEM "&BMP"          NAME mit_WFBMP_0   ACTION SaveAs()            
               ITEM "&JPG"          NAME mit_WFJPG_1   ACTION SaveAs()
               ITEM "&GIF"          NAME mit_WFGIF_2   ACTION SaveAs()
               ITEM "&TIF"          NAME mit_WFTIF_3   ACTION SaveAs()
               ITEM "&PNG"          NAME mit_WFPNG_4   ACTION SaveAs()
               ITEM "&PDF"          NAME mit_WFPDF_5   ACTION SaveAs()
            END POPUP // File
            
            ITEM "&Print"           NAME mit_Print     ACTION Pict2Prn()            
            
            SEPARATOR
            
            ITEM "E&xit"  ACTION ThisWindow.Release
       
			END POPUP // File

         POPUP '?'                    
            ITEM '&About'  ACTION MsgInfo( BT_InfoName() + Space(3) + ;
                                           BT_InfoVersion() + CRLF + ;
                                           BT_InfoAuthor () + CRLF + ;
                                           "E-MAIL:   srvet@adinet.com.uy" + CRLF + ;
                                           "BLOG:     http://srvet.blogspot.com", "Info" )
                                           
         END POPUP // Info
         
         @  0, 0 IMAGE imgTestImage PICTURE NIL ACTION NIL
         
      END MENU // MAIN

      DEFINE STATUSBAR FONT 'Verdana' SIZE 8
          STATUSITEM ""
          STATUSITEM ""
          DATE WIDTH 80
          CLOCK WIDTH 90
      END STATUSBAR
      
   END WINDOW // frmBTExp_IC

   CENTER WINDOW   frmBTExp_IC
   ACTIVATE WINDOW frmBTExp_IC
   
RETURN // BTExplore.Main()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

PROCEDURE BTExp_OpenImgFile()                 // Open an Image file

   BT_BitmapRelease ( hImage )                        // Release from memory
   
   BT_HMGSetImage( "frmBTExp_IC", "imgTestImage", 0 ) // Release from form ( is this usage correct ? )
   
   frmBTExp_IC.StatusBar.Item( 1 ) := ''
   
   frmBTExp_IC.mitSaveAs.Enabled := .F.
   frmBTExp_IC.mit_Print.Enabled := .F.

   cImgFilName := Getfile( { {'PNG Files','*.png'},;     // acFilter
                             {'JPG Files','*.jpg'},;
                             {'BMP Files','*.bmp'},;
                             {'TIF Files','*.tif'},;
                             {'GIF Files','*.gif'} },;                          
                              'Open Image' ) 

   IF ! EMPTY( cImgFilName ) .OR. FILE( cImgFilName )  
   
      IF HL_IsImgFile( cImgFilName )
      
         hImage := BT_BitmapLoadFile( cImgFilName )
  
         BT_HMGSetImage( "frmBTExp_IC", "imgTestImage", hImage)      
         
         frmBTExp_IC.StatusBar.Item( 1 ) := cImgFilName
         
         frmBTExp_IC.mitSaveAs.Enabled := .T.
         frmBTExp_IC.mit_Print.Enabled := .T.
      ELSE
         MsgStop( "Couldn't open " + cImgFilName + " file as a image !"+CRLF+CRLF+;
                  "Not Image File OR unsupported file format ! ", "OPEN ERROR !" )
      ENDIF
      
   ENDIF ! EMPTY( cBMFileName )
   
RETURN // BTExp_OpenImgFile()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

PROCEDURE SaveAs()

   LOCAL nNewImageType,;
         cNewImageType,;
         cTargetFileNam,;
         lContinue := .T.
         
   LOCAL nImgOrjWidth,;     
         nImgOrjHeight,;
         nAspectRatio,;
         nImgPDFWidth,;
         nImgPDFHeight,;
         lSelPDF         
         
   IF ! EMPTY( cImgFilName ) .AND. hImage # 0
   
      nNewImageType  := VAL( RIGHT( This.Name, 1 ) )
      cNewImageType  := SUBSTR( This.Name, 7, 3 )
      cTargetFileNam := LEFT( cImgFilName, LEN( cImgFilName )- 3 ) + cNewImageType

      IF FILE( cTargetFileNam )
          
         lContinue := MsgYesNo( cTargetFileNam + " file exist;" + CRLF + CRLF +;
                                         "OVERWRITE ?", "Confirm Overwrite" )
      ENDIF
      
      IF lContinue                             
         
         IF nNewImageType < 5 
         
            IF BT_BitmapSaveFile( hImage, cTargetFileNam, nNewImageType )
               MsgInfo( "Image saved as " + cNewImageType + " to " + cTargetFileNam )
            ELSE
               MsgInfo( "Saving as " + cNewImageType + " is UNSUCCESSFUL !", "ERROR !")            
            ENDIF         
            
         ELSE  // Target is PDF
         
            Pict2PDF( cTargetFileNam )
            
         ENDIF nNewImageType < 5 
         
      ENDIF lContinue                             
      
   ENDIF   
   
RETURN // SaveAs()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

PROCEDURE Pict2PDF( ;
                    cTargetFileNam )             

   LOCAL cTmpFName := TEMPFILE(, "png")
   
   nImgOrjWidth  := BT_BitmapWidth( hImage )            
   nImgOrjHeight := BT_BitmapHeight( hImage )
   
   nImgPDFWidth  := MIN( nImgOrjWidth / 2.54, 170 )
   
   IF nImgPDFWidth # nImgOrjWidth            
      nImgPDFHeight := nImgOrjHeight / ( nImgOrjWidth / nImgPDFWidth )
   ELSE
      nImgPDFHeight :=  nImgOrjHeight
   ENDIF   
   
   BT_BitmapSaveFile( hImage, cTmpFName, 4 )
   
   SELECT HPDFDOC ( cTargetFileNam ) TO lSelPDF // papersize HPDF_PAPER_A4
   
   IF lSelPDF
      START HPDFDOC
   
         START HPDFPAGE
            @ 20,  20 HPDFPRINT IMAGE cTmpFName WIDTH nImgPDFWidth  HEIGHT nImgPDFHeight
         END HPDFPAGE   
      
      END HPDFDOC

      IF FILE( cTargetFileNam )            
         MsgInfo( "PDF Builded as " + cTargetFileNam ) 
      ELSE
         MsgStop( "PDF Building Unsuccessful :(" + CRLF + CRLF + ;
                  "May be UNICODE incompatibilty isssue;" + CRLF + ;
                  "Please check your folder for file names.", ;                                                     
                  "Unexpected ERROR !" ) 
      ENDIF FILE( cTargetFileNam )                           
      
   ELSE   
      MsgStop( "SELECT PDFDOC is unsuccessful :(", "ERROR !" )         
   ENDIF lSelPDF
   
   FILEDELETE( cTmpFName )
            
RETURN // Pict2PDF()            

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

PROCEDURE Pict2Prn()                      // ( previously loaded ) Picture -> Print

   LOCAL lSelPrntr
   
   SELECT PRINTER DIALOG TO lSelPrntr PREVIEW
   
   IF lSelPrntr
 	   START PRINTDOC 
 	   	START PRINTPAGE
               @ 20, 20 PRINT IMAGE cImgFilName;
        			       WIDTH  170 ;
	          		 HEIGHT 170 
 	   	END PRINTPAGE
 	   END PRINTDOC 
      MsgInfo('Print Picture Finished')
   ELSE   
      MsgBox( "Printing Picture is unsuccessful :(" )
   ENDIF lSelPrntr
   
RETURN // Pict2Prn()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

FUNCTION HL_IsImgFile( ;
                         cFileName )
   LOCAL lRVal    := .F.
   
   LOCAL aIFSigns := { ;                      // Image file signatures
                       { | c1 | SUBSTR( c1, 1, 4 ) = "GIF8" },;  
                       { | c1 | SUBSTR( c1, 7, 4 ) = "JFIF" },;
                       { | c1 | SUBSTR( c1, 2, 3 ) = "PNG"  },; 
                       { | c1 | SUBSTR( c1, 1, 2 ) = "BM"   },;
                       { | c1 | SUBSTR( c1, 1, 3 ) = "II*"  } }
                       
   LOCAL nFilHNo,;     // Open File for Read Only.
         nFerror,;
         nReaded,;
         nHdrLen := 10
         
   LOCAL cHeader := SPACE( nHdrLen ),;
         b1IFSign
         
   IF FILE( cFileName )
      nFilHNo := FOPEN( cFileName )     // Open File for Read Only.
      nFerror := FERROR()   
      IF nFerror == 0                 // File open ok.
         nReaded := FREAD( nFilHNo, @cHeader, nHdrLen)
         IF nHdrLen == nReaded               // READ ok.
            FOR EACH b1IFSign IN aIFSigns
               IF EVAL( b1IFSign, cHeader )
                  lRVal := .T.            
                  EXIT
               ENDIF   
            NEXT b1IFSign
         ENDIF nHdrLen == nReaded               // READ ok.
      ENDIF nFerror == 0                 // File open ok.      
      FCLOSE( nFilHNo )
   ENDIF FILE( cFileName )
                       
RETURN lRVal // HL_IsImgFile()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.   
